PrefabFiles = {
	"finnthehuman", "demonbloodsword", "greenbackpack",
}

Assets = {
    Asset( "IMAGE", "images/saveslot_portraits/finnthehuman.tex" ),
    Asset( "ATLAS", "images/saveslot_portraits/finnthehuman.xml" ),

    Asset( "IMAGE", "images/selectscreen_portraits/finnthehuman.tex" ),
    Asset( "ATLAS", "images/selectscreen_portraits/finnthehuman.xml" ),
	
    Asset( "IMAGE", "images/selectscreen_portraits/finnthehuman_silho.tex" ),
    Asset( "ATLAS", "images/selectscreen_portraits/finnthehuman_silho.xml" ),

    Asset( "IMAGE", "bigportraits/finnthehuman.tex" ),
    Asset( "ATLAS", "bigportraits/finnthehuman.xml" ),
	
	Asset( "IMAGE", "images/map_icons/finnthehuman.tex" ),
	Asset( "ATLAS", "images/map_icons/finnthehuman.xml" ),
	
	Asset( "IMAGE", "images/avatars/avatar_finnthehuman.tex" ),
    Asset( "ATLAS", "images/avatars/avatar_finnthehuman.xml" ),
	
	Asset( "IMAGE", "images/avatars/avatar_ghost_finnthehuman.tex" ),
    Asset( "ATLAS", "images/avatars/avatar_ghost_finnthehuman.xml" ),

}

-- This library function allows us to use a file in a specified location.
-- Allows use to call global environment variables without initializing them in our files.
modimport("libs/env.lua")

-- Actions Initialization.
use "data/actions/init"

-- Component Initialization.
use "data/components/init"

local require = GLOBAL.require
local STRINGS = GLOBAL.STRINGS
local Ingredient = GLOBAL.Ingredient
local RECIPETABS = GLOBAL.RECIPETABS
local Recipe = GLOBAL.Recipe
local TECH = GLOBAL.TECH

STRINGS.NAMES.DEMONBLOODSWORD = "Demon Blood Sword"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.DEMONBLOODSWORD = "It's so.. red"

STRINGS.NAMES.GREENBACKPACK = "Green Backpack"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.GREENBACKPACK = "It's so.. green"
-- The character select screen lines
STRINGS.CHARACTER_TITLES.finnthehuman = "I am Finn the Human"
STRINGS.CHARACTER_NAMES.finnthehuman = "Finn"
STRINGS.CHARACTER_DESCRIPTIONS.finnthehuman = "*Uses evil Demon Blood Sword\n*Enjoys sleeping\n*Loves friendly animals"
STRINGS.CHARACTER_QUOTES.finnthehuman = "\"Homies help homies\""

local containers = require("containers")

local function GreenBackpackPostInit(inst)
    
    local oldwidgetsetup = containers.widgetsetup
    containers.widgetsetup = function(container, prefab)
    if not prefab and container.inst.prefab == "greenbackpack" then
        prefab = "piggyback"
    end
    oldwidgetsetup(container, prefab)
    end

    --AddReplicableComponent("container")

	if not inst.components.characterspecific then
		inst:AddComponent("characterspecific")
    end
	-- Prefab name of character.
	inst.components.characterspecific:SetOwner("finnthehuman")

	-- Determine if we want to allow this item to be stored in a chest or backpack.
	inst.components.characterspecific:SetStorable(false)
	-- Set the speech which will be played for all characters who can't pick up this item.
	inst.components.characterspecific:SetComment("This isn't mine, I shouldn't touch it.")

	return inst
end

local function DemonSwordPostInit(inst)

    if not inst.components.characterspecific then
        inst:AddComponent("characterspecific")
    end
    -- Prefab name of character.
    inst.components.characterspecific:SetOwner("finnthehuman")

    -- Determine if we want to allow this item to be stored in a chest or backpack.
    inst.components.characterspecific:SetStorable(false)
    -- Set the speech which will be played for all characters who can't pick up this item.
    inst.components.characterspecific:SetComment("This isn't mine, I shouldn't touch it.")

    return inst
end

local demonbloodsword_recipe = AddRecipe("demonbloodsword",
    {GLOBAL.Ingredient("nightsword", 1), GLOBAL.Ingredient("horn", 1), GLOBAL.Ingredient("monstermeat", 20)},
    RECIPETABS.MAGIC, TECH.MAGIC_THREE,
    nil, nil, nil, nil, nil,
    "images/inventoryimages/demonbloodsword.xml", "demonbloodsword.tex")
    demonbloodsword_recipe.tagneeded = false
    demonbloodsword_recipe.builder_tag = "demonbloodsword_builder"

AddPrefabPostInit("finnthehuman", function(inst)

    if not GLOBAL.TheWorld.ismastersim then
        return
    end

local function onkilledother(inst, data)
    -- KAJ: what happens if mobs kill someone?
    local victim = data.victim
            if victim.prefab == "crow" or
            victim.prefab == "robin" or
            victim.prefab == "robin_winter" then
                inst.components.sanity:DoDelta(-5)
                inst.components.talker:Say("I'm sorry Mr. Birdy")
            elseif victim.prefab == "butterfly" then
                inst.components.sanity:DoDelta(-5)
                inst.components.talker:Say("I'm sorry Miss Butterfly")
            elseif victim.prefab == "rabbit" then
                inst.components.sanity:DoDelta(-5)
                inst.components.talker:Say("I'm sorry Mr. Rabbit")
            elseif victim.prefab == "perd" then
                inst.components.sanity:DoDelta(-5)
                inst.components.talker:Say("I'm sorry Mr. Turkey")
            elseif victim.prefab == "babybeefalo" then 
                inst.components.sanity:DoDelta(-5)
                inst.components.talker:Say("I'm sorry little Beefalo")
            elseif victim.prefab == "mole" then
                inst.components.sanity:DoDelta(-5)
                inst.components.talker:Say("I'm sorry Mr. Mole")
            elseif victim.prefab == "prey" then
                inst.components.sanity:DoDelta(-5)
                inst.components.talker:Say("Forgive me")

            elseif 	victim.prefab == "spider" or
            	victim.prefab == "spider_warrior" or
            	victim.prefab == "spiderqueen" or
            	victim.prefab == "tentacle" or 
            	victim.prefab == "tentacle_pillar" or
            	victim.prefab == "worm" or
            	victim.prefab == "bunnyman" or
            	victim.prefab == "hound" or
            	victim.prefab == "firehound" or
            	victim.prefab == "icehound" or
            	victim.prefab == "krampus" or
            	victim.prefab == "ghost" or
            	victim.prefab == "knight" or
            	victim.prefab == "knight_nightmare" or
            	victim.prefab == "bishop" or
            	victim.prefab == "bishop_nightmare" or
            	victim.prefab == "rook" or
            	victim.prefab == "rook_nightmare" or
            	victim.prefab == "spider_hider" or
            	victim.prefab == "spider_spitter" or
            	victim.prefab == "spider_dropper" or
            	victim.prefab == "bat" or
            	victim.prefab == "crawlinghorror" or
            	victim.prefab == "crawlingnightmare" or
            	victim.prefab == "terrorbreak" or
            	victim.prefab == "nightmarebeak" or
            	victim.prefab == "lureplant" or
            	victim.prefab == "walrus" or
            	victim.prefab == "sluper" or
            	victim.prefab == "tallbird" or
            	victim.prefab == "frog" or
            	victim.prefab == "mosquito" or
            	victim.prefab == "killerbee" or
            	victim.prefab == "pigguard" or
            	victim.prefab == "merm" or
            	victim.prefab == "leif" or
            	victim.prefab == "warg" or
            	victim.prefab == "leif_sparse" or	
            	victim.prefab == "birchnutdrake" or
            	victim.prefab == "deciduousmonster" or
            	victim.prefab == "mossling" then
            	inst.components.talker:Say("I'll slay anything that's evil. That's my deal!")
            

            elseif victim.prefab == "deerclops" or
            		victim.prefab == "bearger" or
            		victim.prefab == "moose" or
            		victim.prefab == "dragonfly" or
            		victim.prefab == "minotaur" then
            	inst.components.talker:Say("Holy stuff! That was AWESOME!")
            	inst.components.sanity:DoDelta(inst.components.sanity.max)
    		end
    end
    
    inst:ListenForEvent("killed", onkilledother)

end)

local function DeepSleeper(inst)
    if not GLOBAL.TheWorld.ismastersim then
    return
    end
   local oldonsleep = inst.components.sleepingbag.onsleep
   inst.components.sleepingbag.onsleep = function(inst, sleeper)
      oldonsleep(inst, sleeper)
      if sleeper.prefab == "finnthehuman" then
         inst.deeptask = sleeper:DoPeriodicTask(1, function()
            if inst.sleeptask ~= nil then
            sleeper.components.sanity:DoDelta(2, true)
        elseif inst.deeptask ~= nil then
                inst.deeptask:Cancel()
                inst.deeptask = nil
            end
         end)
      end
    end
end

AddSimPostInit(greenbackpack)
AddPrefabPostInit("greenbackpack", GreenBackpackPostInit)
AddPrefabPostInit("demonbloodsword", DemonSwordPostInit)
AddPrefabPostInit("bedroll_straw", DeepSleeper)
AddPrefabPostInit("bedroll_furry", DeepSleeper) 
AddPrefabPostInit("tent", DeepSleeper)
AddPrefabPostInit("siestahut", DeepSleeper)

-- Custom speech strings
STRINGS.CHARACTERS.FINNTHEHUMAN = require "speech_finnthehuman"

-- The character's name as appears in-game 
STRINGS.NAMES.FINNTHEHUMAN = "Finn"

-- The default responses of examining the character
STRINGS.CHARACTERS.GENERIC.DESCRIBE.FINNTHEHUMAN = 
{
	GENERIC = "It's Finn!",
	ATTACKER = "That Finn looks shifty...",
	MURDERER = "Murderer!",
	REVIVER = "Finn, friend of ghosts.",
	GHOST = "Finn could use a heart.",
}

AddMinimapAtlas("images/map_icons/finnthehuman.xml")

-- Add mod character to mod character list. Also specify a gender. Possible genders are MALE, FEMALE, ROBOT, NEUTRAL, and PLURAL.
AddModCharacter("finnthehuman", "MALE")

