local assets = {
	Asset("ANIM", "anim/demonbloodsword.zip"),
	Asset("ANIM", "anim/swap_demonbloodsword.zip"),

	Asset("ATLAS", "images/inventoryimages/demonbloodsword.xml"),
	Asset("IMAGE", "images/inventoryimages/demonbloodsword.tex")
}

local function onequip(inst, owner)
	owner.AnimState:OverrideSymbol("swap_object", "swap_demonbloodsword", "demonbloodsword")
	owner.AnimState:Show("ARM_carry")
	owner.AnimState:Hide("ARM_normal")
end

local function onunequip(inst, owner)
	owner.AnimState:Hide("ARM_carry")
	owner.AnimState:Show("ARM_normal")
end

local function onattack_demonbloodsword(inst, attacker, victim)

	if victim ~= nil then
		local onepercent = inst.components.finiteuses.total / 100
       			if (inst.components.finiteuses.current) < inst.components.finiteuses.total then
            	inst.components.finiteuses:Use(-2)

            	elseif (inst.components.finiteuses.current) == inst.components.finiteuses.total then
            	inst.components.finiteuses:Use(-onepercent)
				end
	end

    if attacker and attacker.components.hunger then
		attacker.components.hunger:DoDelta(-1)

    end
end

local function fn(Sim)
	local inst = CreateEntity()
	inst.entity:AddTransform()
	inst.entity:AddAnimState()

	inst.entity:AddTransform()
	inst.entity:AddAnimState()
	inst.entity:AddSoundEmitter()
    inst.entity:AddNetwork()
	
	inst.AnimState:SetBank("demonbloodsword")
    inst.AnimState:SetBuild("demonbloodsword")
    inst.AnimState:PlayAnimation("idle")  
    
    MakeInventoryPhysics(inst)

    if not TheWorld.ismastersim then
    	return inst
    end

    inst.entity:SetPristine()

	inst:AddComponent("characterspecific")

	inst:AddTag("sharp")

	inst:AddComponent("finiteuses")

    inst.components.finiteuses:SetConsumption(ACTIONS.CHOP, 3)
    inst.components.finiteuses:SetConsumption(ACTIONS.MINE, 3)
    inst.components.finiteuses:SetConsumption(ACTIONS.HAMMER, 3)
   	inst.components.finiteuses:SetOnFinished(inst.Remove)

	inst:AddComponent("weapon")
	inst.components.weapon:SetDamage(72)
	inst.components.weapon:SetAttackCallback(onattack_demonbloodsword)

	inst:AddComponent("tool")
    inst.components.tool:SetAction(ACTIONS.CHOP, 50)
    inst.components.tool:SetAction(ACTIONS.MINE, 50)
    inst.components.tool:SetAction(ACTIONS.HAMMER, 50)
    
    inst:AddTag("irreplaceable")

	inst:AddComponent("equippable")
	inst.components.equippable.keepondeath = true
	inst.components.equippable:SetOnEquip(onequip)
	inst.components.equippable:SetOnUnequip(onunequip)
	inst.components.equippable.dapperness = TUNING.CRAZINESS_MED
	
	inst:AddComponent("inspectable")
	
	inst:AddComponent("inventoryitem")
	inst.components.inventoryitem.keepondeath = true
	inst.components.inventoryitem.imagename = "demonbloodsword"
	inst.components.inventoryitem.atlasname = "images/inventoryimages/demonbloodsword.xml"

	return inst
end

return Prefab("common/inventory/demonbloodsword", fn, assets)
